#version 130
#extension GL_EXT_gpu_shader4 : enable
// the version and open GL extension
// should be the first line of the shader
/////////////////////////////////////////////////////////////////////////////////
// Kochcurve CarpetMod01.fsh  by   tholzer
//https://www.shadertoy.com/view/NdscD2
// Licence CC0
// Adapted, trivialy, for use in VGHD player
/////////////////////////////////////////////
uniform float u_Elapsed;    // The elapsed time in seconds
uniform vec2  u_WindowSize; // Window dimensions in pixels

#define iTime u_Elapsed*0.314159  //*0.1666
#define iResolution u_WindowSize

//#define mouse AUTO_MOUSE
//#define MOUSE_SPEED vec2(vec2(0.5,0.577777) * 0.25)
//#define MOUSE_POS   vec2((1.0+cos(iTime*MOUSE_SPEED))*u_WindowSize/2.0)
//#define MOUSE_PRESS vec2(0.0,0.0)
//#define AUTO_MOUSE  vec4( MOUSE_POS, MOUSE_PRESS )
//#define RIGID_SCROLL
// alternatively use static mouse definition
#define iMouse vec4(0.0,0.0, 0.0,0.0)
//#define iMouse vec4(512,256,180,120)
uniform sampler2D iChannel0;
uniform sampler2D iChannel1;
uniform sampler2D iChannel2;
uniform sampler2D iChannel3;
vec4 texture2D_Fract(sampler2D sampler,vec2 P) {return texture2D(sampler,fract(P));}
vec4 texture2D_Fract(sampler2D sampler,vec2 P, float Bias) {return texture2D(sampler,fract(P),Bias);}
#define texture2D texture2D_Fract

// Fork of "Kochcurve (variable angles)" by Rxphi. 
//   <https://shadertoy.com/view/sdfcDj
// 2022-01-21 01:40:42

vec2 N(float angle) { return vec2(sin(angle), cos(angle)); }

const float k = 5. / 6. * 3.1415;

//void mainImage( out vec4 fragColor, in vec2 fragCoord )
///////////////////////////////////////////////////////////////////////////////// 
// need to convert this from a void to a function and call it by adding
// a void main(void) { to the end of the shader
// what type of variable will the function return?, it is a color and needs to be a vec4
// change void to vec4 
//void MainImage(out vec4 fragColor, in vec2 fragCoord) 
vec4 mainImage( out vec4 fragColor, in vec2 fragCoord )
{

  vec2 uv = 1.3*(fragCoord-0.5*iResolution.xy)/iResolution.y;
  uv.x = abs(uv.x);
  uv.y += tan(k)*0.5;
    
  vec2 n = N(k);
  float d = dot(uv - vec2(0.5, 0.), n);
  uv -= n*max(0., d)*2.; 
    
  n = N((2./3.)*3.1415);
  uv.x += 0.5;
  int recursionDepth = 4;
  for(int i=0; i < recursionDepth; i++)
  { uv *= 3.;
    uv.x = abs(uv.x - 1.5) - 0.5;
    uv -= n*min(0., dot(uv, n))*2.; 
  }

  float scale = pow(3., float(recursionDepth));
  d = length(uv-vec2(clamp(uv.x, -1., 1.), 0));
//  uv /= scale;
    
  fragColor = vec4(smoothstep(1./iResolution.y, 0.0, d/scale));
  if ((iMouse.z < 0.) || (iMouse.x == 0.))
    fragColor += texture2D(iChannel0, uv/scale*2.-iTime*0.03);
/////////////////////////////////////////////////////////////////////////////////
//the function needs to return a value. 
//it needs to be a vec4
//we will return the varable fragColor 
// usual place for fragColor = vec4( color, 1.0 ); bring the } down below
return fragColor; 
}

///////////////////////////////////////////////////////////////////////////////// 
void main(void) { // this will be run for every pixel of gl_FragCoord.xy
vec4 fragColor = vec4(1.0); // initialize variable fragColor as a vec4 
vec4 cc = mainImage(fragColor, gl_FragCoord.xy); // call function mainImage and assign the return vec4 to cc
gl_FragColor = vec4(cc) * gl_Color; // set the pixel to the value of vec4 cc  and..
}

// ..uses the values of any Color: or Opacity:
// clauses (and any Animate clauses applied to these properties) 
// appearing in the Sprite, Quad or other node invoking the shader 
// in the .scn file.

